//****************************************
//  Digital AnemoMeter Control Program
//  Copyright by K.Takano Magnolia Inc.
//****************************************
//	Ver1.00		2007/12/08	ꍆ(LN^LCD^Cv)
//	Ver1.10		2007/12/21	VALCD:SP521
//	Ver1.10a	2008/12/13	̍فARgC

#include	<p30f2012.h>
//#include	<stdio.h>
#include	<math.h>
#include	<timer.h>
#include	<xlcd.h>
#include	<adc12.h>
#include	<outcompare.h>
#include	<i2c.h>
#include	<uart.h>
#include	"DSP_param.h"

// *** uart.h荇킹 ***
#define UART_ALTRX_ALTTX        0xFFE7  /*Communication through ALT pins*/
#define UART_RX_TX              0xFBE7  /*Communication through the normal pins*/

//#define	PLL4_ON
//#define	USEVECTORCOPY

#ifdef	PLL4_ON
	#define	T3VAL	7370*2-1
	#define	T2VAL	999
	#define	PWM_MAX	T2VAL+1
#else
	#define	T3VAL	7370/2-1
	#define	T2VAL	249
	#define	PWM_MAX	T2VAL+1
#endif

//************************
//  configuration fuses
//************************
_FWDT(WDT_OFF);_FGS(CODE_PROT_OFF);_FOSC(CSW_FSCM_OFF & FRC);
_FBORPOR(PBOR_OFF & PWRT_64 & MCLR_EN);

//*****************
//   User Define
//*****************
#define	VREF		2.50
#define	Thcurrent	4096/VREF*0.5	// dl:5mA
#define	TapNum1		10			// ړς̃^bv
#define	TapNum2		10			// xoZT̃^bv
#define	TapNum3		118			// oZT̃^bv
#define	TapNum4		4			// oZT̃^bv
#define	SensOffset	50			// oZT̃VgR

#define	KEY_DISP	PORTDbits.RD9==0
#define	KEY_FUNC	PORTCbits.RC15==0

// *** Zpl ***
#define	PTEMP_1		505			// T[~X^|Cg1(Œl)
#define	PTEMP_2		802			// T[~X^Z|Cg2(Œl)
#define	PV00_1		440			// x1̕0m/sZ|Cg1(Œl)
#define	PV10_1		550			// x2̕0m/sZ|Cg2(Œl)
#define	PV00_2		705			// x1̕10m/sZ|Cg1(Œl)
#define	PV10_2		980			// x2̕10m/sZ|Cg2(Œl)

//**********************
//   Global Valiables
//**********************
unsigned int	adbuf0,adbuf1,adbuf2;	// AiO͒l
unsigned int	ave_adbuf2;				// pɍXɈړςl
unsigned int	timec;					// 2mS*NJEgpϐ
unsigned int	timecm;					// mainloopp timec
int				pwm_num;				// PWMl
int				delayline1[TapNum1];	// ړςDSPobt@
int				delayline2[TapNum2];	// xoZTDSPobt@
int				delayline3[TapNum3];	// oZTDSPobt@
int				delayline4[TapNum4];	// dhCoDSPobt@
//int 			tmpdelayline[TapNum1];	// VectorCopype|̈->gp
char			scanc,scanc50;			// XLJEg
unsigned char	strg[20];				// ϊp
unsigned char	rsbuf[30];				// 񓯊VAʐMobt@
unsigned char	rsflag;					// 񓯊VAʐMtO
//	Bit0:MABit1:M
unsigned char	rscnt;					//@񓯊VAʐMJE^
unsigned char	rstmout;				//@񓯊VAʐM^CAEgv
unsigned int	pth,pwv,pcr;			//@␳J[uZop
unsigned int	pthv_curve[21];			// Zo␳J[ui[p
long			pv00,pv10;				// 0m/s10m/s̍Z{

//**************************
//   Function Declaration
//**************************
void	wait_timec(unsigned int n);
void	PushDelay1(int din); 
void	PushDelay2(int din); 
void	PushDelay3(int din); 
void	PushDelay4(int din); 
int 	CalOutWave1();
int 	CalOutWave2();
int 	CalOutWave3();
int 	CalOutWave4();
void	lcdlocate(int x,int y);
void	numlocate(int x,int y,unsigned n,int pt);
int		VectorDotProduct();
void	VectorCopy();

// *** 2ms^C}3荞 ***
void	__attribute__((__interrupt__,__shadow__, no_auto_psv)) _T3Interrupt(void)
{
	_T3IF = 0;
	PORTBbits.RB6 = 1;				// IVj^p
	PushDelay2(ADCBUF1);			// xZT[h 
	PushDelay3(ADCBUF2);			// ZT[h
	PushDelay4(ADCBUF0);			// dVgd[h
	adbuf1 = CalOutWave2();
	adbuf2 = CalOutWave3();
	adbuf0 = CalOutWave4();
	if (timec != 0) timec--;		// ^C~Ovϐ--
	if (timecm != 0) timecm--;		// ^C~Ovϐ--
	if ((rsflag & 0x1)!=0) {		// M?
		if(++rstmout>250) {			// ^CAEg500ms?
			rsflag = 0;
			rscnt = 0;
			rstmout = 0;
		}
	}
	ADCON1bits.SAMP = 1; 			// Sampling start 
	if(PORTFbits.RF6==1) {
		if(++scanc>=10) {
			scanc = 0;
			// 20msPWMݒ
			if(adbuf0<(Thcurrent+5)) {
				if (++pwm_num>PWM_MAX) pwm_num = PWM_MAX;
			}
			if(adbuf0>(Thcurrent-5)) {
				if (--pwm_num<0) pwm_num = 0;
			}
			SetDCOC2PWM(pwm_num);	// PWMo
			if(++scanc50>=5) {		// 100msɕlɈړ
				scanc50 = 0;
				PushDelay1(adbuf2);
				ave_adbuf2 = CalOutWave1();
			}
		}
	}
	PORTBbits.RB6 = 0;				// IVj^p
}


// UART U1ARXM荞
void __attribute__((__interrupt__, __shadow__, no_auto_psv)) _AltU1RXInterrupt(void)
{
	unsigned char	rch;

	IFS0bits.U1RXIF=0;
	rch = ReadUART1();
	rstmout = 0;				//@^CAEgJEgNA
	if((rsflag & 0x1)==0) {		// PoCgڎM?
		if (rch==0x2) {
			rsflag = 0x1;
			rscnt = 0;
		}
	} else {
		if (rch==0x3) {			// ŏIiETXjM?
			rsflag = 0x2;		// end flag set
		} else {
			rsbuf[rscnt] = rch;	// Mobt@Ɋi[
			if(++rscnt>=30) {	//@30ȏM̓G[Ƃ
				rsflag = 0;
				rscnt = 0;
			}
		}
	}
}

// ړς̒x̃vbV
void PushDelay1(int din) { 
	VectorCopy(TapNum1-1,delayline1,delayline1+1);
	delayline1[TapNum1-1] = din;
}

// xZT̒x̃vbV(ړςɕύX)
void PushDelay2(int din) { 
	VectorCopy(TapNum2-1,delayline2,delayline2+1);
	delayline2[TapNum2-1] = din;
}

// ZTx̃vbV
void PushDelay3(int din) { 
	VectorCopy(TapNum3-1,delayline3,delayline3+1);
	delayline3[TapNum3-1] = din;
}

// dhCo̒x̃vbV
void PushDelay4(int din) { 
	VectorCopy(TapNum4-1,delayline4,delayline4+1);
	delayline4[TapNum4-1] = din;
}

// fW^tB^1̏o͂vZ
int CalOutWave1() { 
	int tmp;
	tmp = VectorDotProduct(TapNum1, delayline1, coeff1);	// f[^ƌWϘaZiDSPCugpj
	return tmp;
}

// fW^tB^2̏o͂vZ
int CalOutWave2() { 
	int tmp;
	tmp = VectorDotProduct(TapNum2, delayline2, coeff1);	// f[^ƌWϘaZiDSPCugpj
	return tmp;
}

// fW^tB^1̏o͂vZ
int CalOutWave3() { 
	int tmp;
	tmp = VectorDotProduct(TapNum3, delayline3, coeff3);	// f[^ƌWϘaZiDSPCugpj
	return tmp;
}

// fW^tB^4̏o͂vZ
int CalOutWave4() { 
	int tmp;
	tmp = VectorDotProduct(TapNum4, delayline4, coeff4);	// f[^ƌWϘaZiDSPCugpj
	return tmp;
}

// *****************************
//    8Bitp̕VAM 
// *****************************
// Entry	*buffer:NULLŏI镶
void	puts_UART1(unsigned char *buffer)
{
	int	ch;

    /* transmit till NULL character is encountered */
	while(*buffer != '\0'){
		while(U1STAbits.UTXBF);  /* wait if the buffer is full */
		ch = (int)*buffer++;   /* transfer data byte to TX reg */
		U1TXREG = ch;
	}
}

// ***********************
//    LCDɂR̐\
// ***********************
// Entry	n:
void	disp_num(int n)
{
	if(n<0) n = 0;		// 000\
	strg[0] = 0x2;		// STX
	strg[1] = 'L';		// 'L'R}h
	if(n==9999) {		// 9999̓uN
		strg[2] = strg[3] = strg[4] = '=';
	} else {
		strg[2] = ((n/100) % 10) + '0';
		strg[3] = ((n/10 ) % 10) + '0';
		strg[4] = ((n    ) % 10) + '0';
	}
	strg[5] = 0x3;		// ETX
	strg[6] = 0x0;
	puts_UART1(strg);
}

// ************************************
//    PIC16F914ɑ邽STX/ETXt
// ************************************
// Entry	*src:͕A*dsto͕
void	strcpy_with_stxetx(char *src,unsigned char *dst)
{
	*dst++ = 0x2;
	while(*src!='\0') {
		*dst++ = *src++;
	}
	*dst++ = 0x3;
	*dst = '\0';
}

long	lval,lval1,lval2;	// vZplongintϐ
#define	GCALC	10			// Ȃ߂̒Ԕ{(Vtg)

// ******************
//    ␳J[uvZ
// ******************
void	calc_correct_curve()
{
	int	i;

	// 10̑\J[u(0m/s`20m/s܂ŁAPmV)
	const	unsigned int		correct_curve[] = {
		4794, 7527, 7909, 8149, 8324, 8468, 8586, 8691, 8780, 8861, 8933, 
		9337, 9612, 9887,10162,10437,10712,10987,11262,11537,11812
 	};

	// ݉xł̕␳J[u0m/s̔{vZ
	lval1 = PTEMP_2;
	lval1 *= PV00_1;
	lval2 = PTEMP_1;
	lval2 *= PV10_1;
	lval1 -= lval2;
	lval2 = (PTEMP_2-PTEMP_1);
	lval1 /= lval2;
	lval = (long)pth;
	lval = lval * (PV10_1-PV00_1);	// (y2-y1)/(x2-x1)*x
	lval /= lval2;
	lval += lval1;					// +(y1*x2-y2*x1)/(x2-x1)
	lval *= 10;
	lval <<= GCALC;
	lval2 = (long)correct_curve[0];
	pv00 = lval / lval2;
	// ݉xł̕␳J[u10m/s̔{vZ
	lval1 = PTEMP_2;
	lval1 *= PV00_2;
	lval2 = PTEMP_1;
	lval2 *= PV10_2;
	lval1 -= lval2;
	lval2 = (PTEMP_2-PTEMP_1);
	lval1 /= lval2;
	lval = (long)pth;
	lval = lval * (PV10_2-PV00_2);
	lval /= lval2;
	lval += lval1;					// +(y1*x2-y2*x1)/(x2-x1)
	lval *= 10;
	lval <<= GCALC;
	lval2 = (long)correct_curve[10];
	pv10 = lval / lval2;
	// 10̃J[uɔ{|Č݉x̃J[uɕϊApthv_curve[]Ɋi[
	lval = (pv10-pv00)/10;
	for(i=0,lval1=pv00;i<21;i++) {
		lval2 = (long)correct_curve[i];
		lval2 = lval2 * lval1;
		lval2 = lval2 >> GCALC;
		pthv_curve[i] = (int)lval2;
		lval1 += lval;
	}
}

// ************************
//    ␳J[u畗vZ
// ************************
// Exit	: l(~10̒l)
int	calc_v()
{
	int	i,ival,iv;

	ival = pwv * 10;
	if(ival<pthv_curve[0]) ival = pthv_curve[0];
	if(ival>pthv_curve[20])ival = pthv_curve[20];
	for(i=0;i<20;i++) {
		if(ival < pthv_curve[i+1]) break;
	}
	iv = (ival-pthv_curve[i])*10/(pthv_curve[i+1]-pthv_curve[i]);	//@␳
	iv = iv+i*10;
	return iv;
}

float	fval;	// xvZp̕ϐ

// **************
//    C[v
// **************
void	mloop()
{
	int	eep_check();
	int	i,ival,pv;
	unsigned char	dsp_flag;

	if ((KEY_DISP) && (KEY_FUNC)) {	// dɁu\vu@\vȂAAiOl
		wait_timec(200);			//@̂܂ܕ\fobOp[h
		dsp_flag = 1;
		while((KEY_DISP) && (KEY_FUNC));
		wait_timec(200);
	} else dsp_flag = 0;
	PORTFbits.RF6 = 1;				// HJn
	wait_timec(100);
	for(;;) {
		lval = (long)adbuf2;
		lval = lval*483/1024;
		pwv = (int)lval-SensOffset;
		lval = (long)adbuf1;
		lval = lval*VREF*1000/4096;
		pth = (int)lval;
		if(KEY_DISP) {				// \L[ꂽ牷x\
			for(i=0;i<10;i++) {
				fval = (float)pth / 1000.0;
				fval = 10000.0*fval/(VREF-fval);	// RvZ
				fval = (1.0/(log(fval/2100.0)/3850.0+1.0/298.15))-273.15;
				ival = (int)(fval*10.0);
				if(dsp_flag==0) disp_num(ival); else disp_num(pth);
				wait_timec(100);
				disp_num(9999);		// 200msƂɓ_
				wait_timec(100);
			}			
		}
		calc_correct_curve();
		pv = calc_v();
		if(dsp_flag==0) disp_num(pv); else disp_num(pwv);
		timecm = 200;
		while(timecm != 0);
	}
}

// *****************
//    n*2msԑ҂
// *****************
// Entry	n:~2ms
void	wait_timec(unsigned int n)
{
	n = (n >> 1)+1;
	timec = n;
	while(timec != 0);
}

//**********
//   main
//**********
int	main(void)
{     
	pwm_num = 0;
	rsflag = 0;
	scanc = scanc50 = 0;
	PORTBbits.RB9 = 0;
	TRISB = 0x000F;		// AN0`3gp,other:out
	TRISC = 0xc000;		// RC14,15:in,other:out
	TRISD = 0x0200;		// RD10:in,other:out
	PORTFbits.RF6 = 0;
	TRISF = 0x0034;		// RF2,4,5:in,other:out
	INTCON2bits.ALTIVT=1;
	// 12bit ADconverer Initialize
	ConfigIntADC12(ADC_INT_DISABLE);
	OpenADC12(
		ADC_MODULE_ON &			// ADCON1
		ADC_IDLE_CONTINUE &
		ADC_FORMAT_INTG &		// Unsigned Integer
		ADC_CLK_AUTO &  		// AUTO sampling
		ADC_AUTO_SAMPLING_OFF &	// TvIt
		ADC_SAMP_OFF,
		ADC_VREF_EXT_AVSS &		//ADCON2 AN0 Vreff+
		ADC_SCAN_ON &			//CH0 scan on
		ADC_SAMPLES_PER_INT_3 &
		ADC_ALT_BUF_OFF &
		ADC_ALT_INPUT_OFF,
		ADC_SAMPLE_TIME_4 &		// Taq>3.74us([Xg)=4*Tad=4.3us
		ADC_CONV_CLK_SYSTEM &
		ADC_CONV_CLK_2Tcy,		// Tcy=542nS,Tad=1.084us,Tconv=14Tad=15us
		ENABLE_AN0_ANA &		//ADPCFG
		ENABLE_AN1_ANA &
		ENABLE_AN2_ANA &
		ENABLE_AN3_ANA,
		0x000e					//ADCSSL AN1,AN2,AN3 scan
	);
	ADCON1bits.ADON = 1; 		// turn ADC ON
	ADCON1bits.SAMP = 1; 		// Sampling start 
	// UART init 9600bps 8bits stop1 pn,ALT
	CloseUART1();
	ConfigIntUART1(UART_RX_INT_EN & UART_RX_INT_PR3 & UART_TX_INT_DIS);
	OpenUART1(
		UART_EN & UART_IDLE_CON & UART_ALTRX_ALTTX &
		UART_DIS_WAKE & UART_DIS_LOOPBACK &	UART_EN_ABAUD &
		UART_NO_PAR_8BIT & UART_1STOPBIT
		,
		UART_INT_TX_BUF_EMPTY & UART_TX_PIN_NORMAL &
		UART_TX_ENABLE & UART_INT_RX_CHAR &
		UART_ADR_DETECT_DIS & UART_RX_OVERRUN_CLEAR	,
		11
		);
	// TIMER1  1ms(at 7.37MHz)
	OpenTimer3(T3_ON & T3_GATE_OFF & T3_PS_1_1 & T3_SOURCE_INT, T3VAL);	// Timer3:2ms
	ConfigIntTimer3(T3_INT_PRIOR_5 & T3_INT_ON);						// IntTimer3ݒ
	// TIMER2 for OC2 setting
	OpenTimer2(T2_ON & T2_GATE_OFF & T2_PS_1_1 & T2_SOURCE_INT, T2VAL);	// PWM period:7.37KHz
	OpenOC2(OC_IDLE_CON &			// IDLE on;
		OC_TIMER2_SRC &				// Clock Source : Timer2
		OC_PWM_FAULT_PIN_DISABLE, 0, 0);
	SetDCOC2PWM(0);					// ŏPWMo͂Low
	// Enable Interrupt
	DISICNT = 0x0000;
	mloop();
	return(0);
}
