// ************************************
//  SP521Rg[ CCS-CRpCp
//  Copyright by K.Takano Magnolia Inc.
// ************************************
//	Ver1.0	2007/12/20

//#include <stdio.H>
#include	<ctype.h>
#include "16F914.H"
#fuses INTRC_IO,NOWDT,NOPROTECT,NOBROWNOUT
#use delay(clock=8000000)
#use FAST_IO(b)
#use FAST_IO(d)
#use FAST_IO(e)
#use FAST_IO(c)
#use rs232(baud=9600,parity=N,rcv=PIN_C7,xmit=PIN_C6,bits=8,stream=RS232)

#byte	PORTA = 5
#byte	PORTB = 6
#byte	PORTC = 7
#byte	PORTD = 8
#byte	PORTE = 9
#byte	STATUS_REG = 0x3
#byte	LCDCON = 0x107
#byte	LCDPS  = 0x108
#byte	LCDSE0 = 0x11c
#byte	LCDSE1 = 0x11d
#byte	LCDSE2 = 0x11e
#byte	LCDDATA0 = 0x110
#byte	LCDDATA1 = 0x111
#byte	LCDDATA2 = 0x112
#byte	IOCB = 0x96
#byte	RCSTA = 0x18

#bit	RP0 = 3.5
#bit	RP1 = 3.6
#bit	TO = 3.4				// STATUS:TO bit(WDT on)
#bit	SCADD0 = 7.7			// RC7
#bit	SCADD1 = 8.0			// RD0
#bit	RCIF	= 0xc.5

#define	STX	0x2
#define	ETX	0x3

int					scanc;		// 
unsigned int		dispbuf[4];	// LCD\obt@
unsigned int		rsbuf[10];	// VAMobt@
unsigned int		rsflag;		// VAMtO 0:M,1:MI
unsigned int 		rscnt;		// VAMJE^
unsigned int		rstmout;	// VAM^CAEgJE^
unsigned int		pflag;		// powerdown flag
unsigned int		timec;		// 

// LCDZOgp^[@'0','1',...,'9','-','+','C',' '
const	unsigned int	lcdpat[14] = {
	0x3f,0x06,0x5b,0x4f,0x66,0x6d,0x7d,0x27,
	0x7f,0x6f,0x40,0x46,0x39,0x00
	};

void	wait_timec(unsigned int n);
void	sel_bank(int bk);
void	num_set(int16 n);
void	lcd_set();

// *** Timer0荞(4.096ms) ***
#INT_RTCC
void	event()		
{
	if (timec!=0) timec--;
	if(++scanc>25) {
		scanc = 0;
		if((rsflag & 0x1)==0x1) {	// VAʐM^CAEg
			if (++rstmout>2) {
				rsflag = 0x0;
				rscnt = 0;
				rstmout = 0;
			}
		}
	}
	output_bit(PIN_D1,1);	// j^o
	output_bit(PIN_D1,0);
}

// *** RB5͊荞 ***
#INT_RB
void	PB5_isr()
{
	int	dmy;

	delay_ms(50);
	if(input(PIN_B5)==0) {
		if(pflag==0) delay_ms(1000);
		if(input(PIN_B5)==0) {	// 1bĂtO𗧂Ă
			if(pflag==0) {
				pflag=0x1;
				// ŕ\->܂΍
			} else pflag=0;
		}
	}	
	while(input(PIN_B5)==0);
	delay_ms(200);
	dmy = 0;	
}

// *** VAM荞 ***
#int_RDA
void	RDA_isr()
{
	unsigned int		ch;

	ch = fgetc(RS232);
	if((RCSTA & 0x6)==0) {
		if((rsflag & 0x1)==0) {
			if(ch==STX) {			//MJn
				rscnt = 0;
				rsflag = 0x1;
				rstmout = 0;
			}
		} else {
			if(ch==ETX) {
				rsflag = 0x2;		//MI
			} else {
				rsbuf[rscnt] = ch;
				if(++rscnt>=10) {	//
					rsflag = 0;
					rstmout = 0;
					rscnt = 0;
				}
			}
		}
	}
}

// *** 3LCD\obt@Ɋi[ ***
void	num_set(int16 n)
{
	dispbuf[2] = lcdpat[(n/100) % 10]; 
	dispbuf[1] = lcdpat[(n/10 ) % 10]; 
	dispbuf[0] = lcdpat[(n    ) % 10]; 
	lcd_set();	
}

// *** LCD\obt@LCDWX^ɏ ***
void	lcd_set()
{
	unsigned char	ch;
	

	ch = dispbuf[0] & 0x7f;
	if((dispbuf[1] & 0x01)!=0) ch |= 0x80;
	LCDDATA0 = ch;
	ch = dispbuf[1] & 0x7c;
	if((dispbuf[1] & 0x02)!=0) ch |= 0x80;
	LCDDATA1 = ch;
	ch = dispbuf[2] | 0x80;
	LCDDATA2 = ch;
}

// *** 1byte16i𐔒lɕϊ ***
int	ctoh(char ch)
{
	if (islower(ch)!=0) ch=toupper(ch);
	if (ch>='A') return(ch-'A'+10); else return(ch-'0');
}

// *** 1byteiO|ejPPUiɕϊ ***
char	htoc(int ch)
{
	if (ch>=10) return(ch-10+'A'); else return(ch+'0');
}

// *** VAEEPǏoR}h ***
void	eep_read()
{
	unsigned int		addr,data,ch;

	fputc(0x2,RS232);
	fputc('A',RS232);
	addr = ctoh(rsbuf[1])*16+ctoh(rsbuf[2]);
	data = read_eeprom(addr);
	ch = htoc((data>>4) & 0xf);
	fputc(ch,RS232);
	ch = htoc(data & 0xf);
	fputc(ch,RS232);
	data = read_eeprom(addr+1);
	ch = htoc((data>>4) & 0xf);
	fputc(ch,RS232);
	ch = htoc(data & 0xf);
	fputc(ch,RS232);
	fputc(0x3,RS232);
}

// *** VAEEP݃R}h ***
void	eep_write()
{
	unsigned int		addr,data;

	addr = ctoh(rsbuf[1])*16+ctoh(rsbuf[2]);
	data = ctoh(rsbuf[3])*16+ctoh(rsbuf[4]);
	write_eeprom(addr,data);
	data = ctoh(rsbuf[5])*16+ctoh(rsbuf[6]);
	write_eeprom(addr+1,data);
	eep_read();		// ǏoƓԐM
}

// *** C[v ***
void	mloop()
{
//	int16	i;
	int	pat;

	output_bit(PIN_A2,0);
	lcd_set();
	pat = 0x1;
	pflag = 0x0;
//	sleep();
	for(;;) {
		if((rsflag & 0x2)!=0) {	// f[^M?
			switch (rsbuf[0]) {
				case 'L':		// \
					dispbuf[2] = lcdpat[rsbuf[1]-'0'];
					dispbuf[1] = lcdpat[rsbuf[2]-'0'];
					dispbuf[0] = lcdpat[rsbuf[3]-'0'];
					lcd_set();
					break;
				case 'W':		// EEPROM
					eep_write();
					break;
				case 'R':		// EEPROMǏo
					eep_read();
					break;
				defalult : break;
			}
			rsflag = 0;
		}
		if(pflag!=0)	{			// 쒆ɓdL[tO
			output_bit(PIN_A2,1);	// dsPIC̓d؂
			sleep();
//			disable_interrupts(GLOBAL);
//			setup_uart(9600,rsOute);
//			delay_ms(500);
			RCIF = 1;
			rsflag = 0x0;
			rscnt = 0;
			rstmout = 0;
//			enable_interrupts(INT_RDA);
//			reset_cpu();
		}
		output_bit(PIN_A2,0);		// dsPIC̓dON
		if((RCSTA & 0x6)!=0) {
			RCSTA = 0x80;
			RCSTA = 0x90;
		}
		wait_timec(5);
	}
}

void	main()
{
	int	i;

	rsflag = 0x0;
	pflag = 0x0;
	setup_oscillator(OSC_8MHZ);		// 8MHzIV[^Zbg
	for(i=0;i<3;i++) dispbuf[i]=0x0;
	setup_adc_ports(NO_ANALOGS);
	PORTD = 0xda;
	PORTE = 0x0;
	PORTA = 0x4;
	set_tris_b(0x20);		// RB5:in other:out
	set_tris_a(0x00);		// RA all out
	set_tris_c(0x87);		// RC0-3:in 4-7:out
	set_tris_d(0x00);		// RD all out
	set_tris_e(0x01);		// RE0:in other:out
	port_b_pullups(0x20);
	LCDCON = 0xc0;			// off:sleep
	LCDPS  = 0xb2;
	LCDSE0 = 0xff;
	LCDSE1 = 0xfc;
	LCDSE2 = 0xff;
	LCDDATA0 = 0;
	LCDDATA0 = 1;
	LCDDATA0 = 2;
	IOCB = 0x20;			// PB5 interrupt enable
	setup_comparator(NC_NC_NC_NC);
	setup_timer_0(RTCC_INTERNAL | RTCC_DIV_32);
	setup_timer_2(T2_DIV_BY_1,255,1);
//	setup_timer_1(T1_INTERNAL | T1_DIV_BY_8);
	enable_interrupts(INT_RTCC);
//	setup_wdt(WDT_1152MS);
	enable_interrupts(INT_RTCC);
	enable_interrupts(INT_RDA);
	enable_interrupts(INT_RB);
	enable_interrupts(GLOBAL);
	mloop();
}


void	wait_timec(unsigned int n)
{
	timec = n;
	while(timec!=0);
}


